#ifndef _PAGE_CONTROLLER_H
#define _PAGE_CONTROLLER_H

#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <map>

#include "PageComponent.h"
#include "PageDraw.h"
// TODO: goto SDL_Image ?
#include "SOIL.h"


class PageController: public PageDrawLayer {
private:
	const char* id;
	const char* title;
	bool menu = true;
	std::map <const char* , void*> images;
	std::vector<PageDrawComponent*> components;

	void loadImage(const char* filename);
	PageImage* buildImage(void* imageRef);
public:
	PageController(const char* id, const char* title);

	const char* getId();
	const char* getTitle();

	int getImageCount();

	int getDrawCount();
	void drawLayer(); // from super

	void addComponent(PageDrawComponent* component);
	void setMenu(bool menu);
	bool getMenu();

	PageText* buildText(const char* text);
	PageLink* buildLink(const char* url);
	PageImage* buildImage(const char* filename);
};

#endif
