#include "PageFont.h"

PageFont::PageFont() {
}

void PageFont::loadFonts() {
	printf("fonts loadings\n");
	ImGuiIO& io = ImGui::GetIO();
	// NOTE: Load fonts from large to small else scaling doesn't work

	ImFontConfig fontConfigHeaderMain;
	fontConfigHeaderMain.MergeMode = false;
	fontConfigHeaderMain.PixelSnapH = true;
	ImFont* fontHeaderMain = io.Fonts->AddFontFromFileTTF("data/font/roboto-bold.ttf", 24.0f, &fontConfigHeaderMain);

	ImFontConfig fontConfigHeaderSub;
	fontConfigHeaderSub.MergeMode = false;
	fontConfigHeaderSub.PixelSnapH = true;
	ImFont* fontHeaderSub = io.Fonts->AddFontFromFileTTF("data/font/roboto-bold.ttf", 20.0f, &fontConfigHeaderSub);

	ImFontConfig fontConfigNormal;
	fontConfigNormal.MergeMode = false;
	fontConfigNormal.PixelSnapH = true;
	io.Fonts->AddFontFromFileTTF("data/font/lato-blackitalic-webfont.ttf", 16.0f, &fontConfigNormal);
	static ImWchar iconRange[] = { 0xf000, 0xf3ff, 0 };
	ImFontConfig fontConfigNormalIcon;
	fontConfigNormalIcon.MergeMode = true;
	fontConfigNormalIcon.PixelSnapH = true;
	io.Fonts->AddFontFromFileTTF("data/font/fontawesome-webfont.ttf", 16.0f, &fontConfigNormalIcon, iconRange);

	ImFontConfig fontConfigSmall;
	fontConfigSmall.MergeMode = false;
	fontConfigSmall.PixelSnapH = true;
	ImFont* fontSmall = io.Fonts->AddFontFromFileTTF("data/font/lato-blackitalic-webfont.ttf", 12.0f, &fontConfigSmall);

	this->fonts.insert(std::pair<PageFontType,ImFont*>(HEADER_MAIN, fontHeaderMain));
	this->fonts.insert(std::pair<PageFontType,ImFont*>(HEADER_SUB, fontHeaderSub));
	this->fonts.insert(std::pair<PageFontType,ImFont*>(SMALL, fontSmall));

	// swap ImGui main font to normal
	ImFont* font0 = io.Fonts->Fonts.Data[0];
	ImFont* font2 = io.Fonts->Fonts.Data[2];
	io.Fonts->Fonts.Data[0] = font2;
	io.Fonts->Fonts.Data[2] = font0;

	printf("fonts initialized\n");
}

void PageFont::pushFont(PageFontType type) {
	if (NORMAL == type) {
		return;
	}
	if (this->fonts.find(type) == this->fonts.end()) {
		printf("ERR: unknown font: %i\n",type);
		ImGui::PushFont(this->fonts.at(SMALL)); // else pop will error
	} else {
		ImGui::PushFont(this->fonts.at(type));
	}
}

void PageFont::popFont(PageFontType type) {
	if (NORMAL == type) {
		return;
	}
	ImGui::PopFont();
}

PageFont PAGE_FONT;

