#include "FFSiteBackground.h"

struct A {
	const char* text = "ForwardFire";
	ImVec4 color = ImVec4(0.0f,0.5f,0.3f,1.0f);;
	int bgSpeed = 1;
	float x = 10.0f;
	float xOff = 2.0f;
	float y = 20.0f;
	float yOff = 3.0f;
};

static const int LETTERS_MAX = 25;
static A letters[LETTERS_MAX];

static bool rr = true;

FFSiteBackground::FFSiteBackground() {
	for (int i=0;i<LETTERS_MAX;i++) {
		A* a = &letters[i];
		a->bgSpeed = rand() % 100;
		a->x = rand() % (int)ImGui::GetIO().DisplaySize.x;
		a->y = rand() % (int)ImGui::GetIO().DisplaySize.y;
		a->color = ImVec4(0.0f,(i+1)*0.1f,(i+2)*0.01f,(i+3)*0.01f);

		a->xOff = rand() % 3 + 0.1f;
		a->yOff = rand() % 4 + 0.1f;

		int r = rand() % 5;
		if (r == 2) {
			a->xOff = 0 - a->xOff;
		}
		if (r == 3) {
			a->yOff = 0 - a->yOff;
		}
	}
}


void FFSiteBackground::drawLayer(void) {
	ImGui::SetNextWindowSize(ImGui::GetIO().DisplaySize, ImGuiSetCond_Always);
	ImGui::Begin("Background###background", &rr , ImGui::GetIO().DisplaySize, 0.0f,  WINDOW_BACKGROUND_FLAGS);
	for (int i=0;i<LETTERS_MAX;i++) {
		A* a = &letters[i];
		a->bgSpeed--;
		if (a->bgSpeed < 0) {
			a->bgSpeed = 2; //rand() % 10;

			if (a->x > ImGui::GetIO().DisplaySize.x) {
				a->xOff = 0 - a->xOff;
				a->x = ImGui::GetIO().DisplaySize.x;
			}
			if (a->x < 0) {
				a->xOff = 0 - a->xOff;
				a->x = 0;
			}
			if (a->y > ImGui::GetIO().DisplaySize.y) {
				a->yOff = 0 - a->yOff;
				a->y = ImGui::GetIO().DisplaySize.y;
			}
			if (a->y < 0) {
				a->yOff = 0 - a->yOff;
				a->y = 0;
			}
			a->x = a->x+a->xOff;
			a->y = a->y+a->yOff;
		}
		ImGui::SetCursorPos(ImVec2(a->x, a->y));
		ImGui::TextColored(a->color, a->text);
	}
	ImGui::End();
}
