#include "FFSiteDebug.h"

void FFSiteDebug::showSettingsWindow(bool* p_open) {
	ImGui::SetNextWindowSize(ImVec2(300, 200), ImGuiSetCond_FirstUseEver);
	ImGui::Begin("Test Settings", p_open);
	ImGui::ColorEdit3("Background", (float*) &PAGE_WINDOW.backgroundClearColor);
	ImGui::SliderFloat("Margin X",  &PAGE_WINDOW.layoutMarginX, 0.0, 0.4);
	ImGui::SliderFloat("Margin Y",  &PAGE_WINDOW.layoutMarginY, 0.0, 0.2);
	ImGui::Checkbox("Render menu", &PAGE_WINDOW.menuRender);
	ImGui::Checkbox("Render footer", &PAGE_WINDOW.footerRender);
	ImGui::Checkbox("Render FPS", &PAGE_WINDOW.footerRenderFPS);
	ImGui::End();
}

void FFSiteDebug::showLayoutWindow(bool* p_open) {
	ImGui::SetNextWindowSize(ImVec2(300, 200), ImGuiSetCond_FirstUseEver);
	ImGui::Begin("Test Layout", p_open);

	ImGui::BeginChild("Sub1", ImVec2(ImGui::GetWindowContentRegionWidth() * 0.33f,100), true, 0);
	ImGui::SmallButton("Hello 11");ImGui::SameLine();
	ImGui::SmallButton("Hello 12");ImGui::SameLine();
	ImGui::SmallButton("Hello 13");ImGui::SameLine();
	ImGui::SmallButton("Hello 14");
	ImGui::SmallButton("Hello 15");ImGui::SameLine();
	ImGui::SmallButton("Hello 16");
	ImGui::SmallButton("Hello 17");ImGui::SameLine();
	ImGui::SmallButton("Hello 18");ImGui::SameLine();
	ImGui::EndChild();
	ImGui::SameLine();

	static bool bb = true;

	//ImGui::PushStyleVar(ImGuiStyleVar_ChildWindowRounding, 5.0f);
	ImGui::BeginChild("Sub2", ImVec2(ImGui::GetWindowContentRegionWidth() * 0.66f,100), true, 0);
	if (bb) {
		ImGui::Text("Hello 22");
	} else {
		ImGui::Text("Hello 22222222222222.....");
	}
	bb = !ImGui::IsItemHovered();
	ImGui::EndChild();

	//ImGui::PopStyleVar();

	static bool bc = true;
	float f = 15.0f;
	if (bc) {
		f+=10;
	}

	ImGui::BeginGroup();
	ImGui::PushStyleVar(ImGuiStyleVar_ChildWindowRounding, f);
	ImGui::BeginChild("Main", ImVec2(ImGui::GetWindowContentRegionWidth(),-1), false, ImGuiWindowFlags_ShowBorders);
	ImGui::Text("Hello Main");
	ImGui::EndChild();
	ImGui::PopStyleVar();
	ImGui::EndGroup();
	bc = !ImGui::IsItemHovered();
	bc = !bc;

	ImGui::End();
}

void FFSiteDebug::drawComponent(void) {
	if (ImGui::Button("\uf241 Fullscreen")) {
		if (PAGE_WINDOW.windowFullScreen) {
			SDL_SetWindowFullscreen(PAGE_WINDOW.window, 0);
		} else {
			SDL_SetWindowFullscreen(PAGE_WINDOW.window, SDL_WINDOW_FULLSCREEN);
		}
		PAGE_WINDOW.windowFullScreen = !PAGE_WINDOW.windowFullScreen;
	}
	if (ImGui::Button("\uf1fa Test Demo")) {
		renderDemo ^= 1;
	}
	if (ImGui::Button("\uf1fe Test Metrics")) {
		renderMetrics ^= 1;
	}
	if (ImGui::Button("\uf1fb Test Layout")) {
		renderLayout ^= 1;
	}
	if (ImGui::Button("\uf1ff Page Options")) {
		renderSettings ^= 1;
	}
}

void FFSiteDebug::drawLayer(void) {
	if (renderDemo) {
		ImGui::SetNextWindowPos(ImVec2(50, 50), ImGuiSetCond_FirstUseEver);
		ImGui::ShowTestWindow(&renderDemo);
	}
	if (renderMetrics) {
		ImGui::SetNextWindowPos(ImVec2(60, 60), ImGuiSetCond_FirstUseEver);
		ImGui::ShowMetricsWindow(&renderMetrics);
	}
	if (renderLayout) {
		ImGui::SetNextWindowPos(ImVec2(70, 70), ImGuiSetCond_FirstUseEver);
		showLayoutWindow(&renderLayout);
	}
	if (renderSettings) {
		ImGui::SetNextWindowPos(ImVec2(80, 80), ImGuiSetCond_FirstUseEver);
		showSettingsWindow(&renderSettings);
	}
}

